/******************************************************************************
*    Copyright (c) 2009-2012 by Hisi.
*    All rights reserved.
* ***
*    Create by Czy. 2012-03-19
*
******************************************************************************/

#include <config.h>

#define readl(_a)        (*(volatile unsigned int *)(_a))
#define writel(_v, _a)   (*(volatile unsigned int *)(_a) = (_v))

/******************************************************************************/

static inline void delay(unsigned int cnt)
{
	do {
		__asm__ __volatile__("nop");
	} while (cnt--);
}

/******************************************************************************/
void set_core_voltage(void)
{
	unsigned int regval, hpm_code, hpm_code_average, volt_reg_val, delay_count;
	unsigned int max_threshold =readl(REG_BASE_SCTL+REG_SC_GEN19) >>16;
	unsigned int min_threshold = readl(REG_BASE_SCTL+REG_SC_GEN19) & 0xffff;
	unsigned int max_volt = readl(REG_BASE_SCTL+REG_SC_GEN17) >> 16;
	unsigned int min_volt = readl(REG_BASE_SCTL+REG_SC_GEN17) & 0xffff;
	unsigned int middle_volt = readl(REG_BASE_SCTL+REG_SC_GEN18) & 0xffff;

	/* hpm 0             */
	/* clock is 200M, set time division to (200/50 - 1) */
	regval = readl(0xf8a23058);
	regval &= 0xffffffc0;
	regval |= 3;
	writel(regval, 0xf8a23058);

	/* set monitor period to 2ms */
	regval = readl(0xf8a23064);
	regval &= 0x00ffffff;
	regval |= (1 << 24);
	writel(regval, 0xf8a23064);

	/* hpm enable */
	regval = readl(0xf8a23058);
	regval |= (1 << 24);
	writel(regval, 0xf8a23058);

	/* hpm monitor enable */
	regval = readl(0xf8a23058);
	regval |= (1 << 26);
	writel(regval, 0xf8a23058);

	delay(6000000);

	regval = readl(0xf8a2305c);
	hpm_code = (regval & 0x3ff);
	hpm_code_average = hpm_code;
	hpm_code = ((regval >> 12) & 0x3ff);
	hpm_code_average += hpm_code;

	regval = readl(0xf8a23060);
	hpm_code = (regval & 0x3ff);
	hpm_code_average += hpm_code;
	hpm_code = ((regval >> 12) & 0x3ff);
	hpm_code_average += hpm_code;

	hpm_code_average = (hpm_code_average>>2);

	volt_reg_val = readl(0xf8a23018);
	volt_reg_val &= 0xffff;
	if (hpm_code_average >= max_threshold) {
		volt_reg_val |= max_volt<<16; /* ff chip */
	} else if (hpm_code_average < min_threshold) {
		volt_reg_val |= min_volt<<16; /* ss chip */
	} else {
		volt_reg_val |= middle_volt<<16; /* tt chip */
	}
	writel(volt_reg_val, 0xf8a23018);
	writel(hpm_code_average, 0xf8000F00);
	writel(volt_reg_val, 0xf8000F04);
	delay(8000000);

	return;
}
/******************************************************************************/

long long get_chipid_reg(void)
{
	long long chipid = 0;
	long long verid = 0;

	chipid = (long long)readl(REG_BASE_SCTL + REG_SC_SYSID0);
	verid = (long long)readl(REG_BASE_PERI_CTRL + REG_PERI_SOC_FUSE);
	chipid = ((verid & (0x1F << 16)) << 16) | (chipid & 0xFFFFFFFF);

	return chipid;
}

/******************************************************************************/

unsigned int get_ca_vendor_reg(void)
{
	unsigned long ca_vendor = 0;

	// TODO: XXXX

	return ca_vendor;
}

/******************************************************************************/

void reset_cpu(unsigned long addr)
{
	/* unclock wdg */
	writel(0x1ACCE551, REG_BASE_WDG0 + 0x0C00);
	/* wdg load value */
	writel(0x00000100, REG_BASE_WDG0 + 0x0000);
	/* bit0: int enable bit1: reboot enable */
	writel(0x00000003, REG_BASE_WDG0 + 0x0008);

	for (; ;)
		;
}
/******************************************************************************/
