/**
 * ddr_training_custom.h
 *
 * Copyright (c) 2009-2014, HiSilicon Technologies Co., Ltd.
 * All rights reserved.
 *
 * DDR training custom define.
 */

/* config DDRC, PHY, DDRT typte */
#define DDR_DDRC_V510_CONFIG
#define DDR_PHY_S40_CONFIG
#define DDR_DDRT_S40_CONFIG

/* config special item */
#define DDR_MPR_TRAINING_CONFIG

/* config DDRC, PHY, DDRT base address */
/* [CUSTOM] DDR DMC base register */
#define DDR_REG_BASE_DMC0              0xff588000
#define DDR_REG_BASE_DMC1              0xff589000
/* [CUSTOM] DDR PHY base register */
#define DDR_REG_BASE_PHY0              0xff58c000
#define DDR_REG_BASE_PHY1              0xff58d000
/* [CUSTOM] DDR DDRT base register */
#define DDR_REG_BASE_DDRT              0xff350000
/* [CUSTOM] DDR training item system control */
#define DDR_REG_BASE_SYSCTRL           0xf8000000

/* [CUSTOM] Must defined AXI when config DDRC V510 */
#define DDR_REG_BASE_AXI		       0xff580000

/* config offset address */
#define SYSCTRL_DDRT_PATTERN      0x8c  /* [CUSTOM] ddrt reversed data */
#define SYSCTRL_DDRT_PATTERN_SEC  0x90  /* [CUSTOM] PHY2 ddrt reversed data */
#define SYSCTRL_DDR_TRAINING_CFG  0xd0  /* [CUSTOM] ddr training item */
#define SYSCTRL_DDR_TRAINING_STAT 0x9c  /* [CUSTOM] ddr training stat */

/* config other special */
/* [CUSTOM] the number of PHY */
#define DDR_PHY_NUM                    2
/* [CUSTOM] DDR training start address. MEM_BASE_DDR*/
#define DDRT_CFG_BASE_ADDR             0x10000000
/* [CUSTOM] SRAM start address. NOTE: Makefile will parse it. */
#define DDR_TRAINING_RUN_STACK         0xFFFF0C00

#define DDR_RELATE_REG_DECLARE
#define DDR_TRAINING_SAVE_REG_FUNC(relate_reg, mask) \
	ddr_training_save_reg_custom(relate_reg, mask)

#define DDR_TRAINING_RESTORE_REG_FUNC(relate_reg) \
	ddr_training_restore_reg_custom(relate_reg)

struct tr_custom_reg {
	unsigned int sec_bypass[DDR_PHY_NUM];
	unsigned int qosb_buff_byp;
};
void ddr_training_save_reg_custom(void *relate_reg, unsigned int mask);
void ddr_training_restore_reg_custom(void *relate_reg);
