/******************************************************************************
*    Copyright (c) 2009-2014 by Hisi.
*    All rights reserved.
* ***
*    Create by zengzhongliang. 2015-12-21
*
******************************************************************************/
#include <common.h>

int do_turing_core_volt(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32 core_pwm, volt;
	static u32 init_core_pwm = 0;

	if (argc < 2) {
		cmd_usage(cmdtp);
		return 1;
	}

	volt = simple_strtoul(argv[1], NULL, 10) / 10 * 10;
	if (volt > 50) {
		printf("Failed: tuning range from 0 to 50!!!\n");
		return 1;
	}
	printf("tuning core volt %dmv up\n", volt);

	if (!init_core_pwm)
		init_core_pwm = *(u32 *)0xf8a23018;

	core_pwm = (((init_core_pwm >> 16) - (volt / 5 * 2)) << 16) | (init_core_pwm & 0xffff);
	*(u32 *)0xf8a23018 = core_pwm;

	return 0;
}

U_BOOT_CMD(
	tune, CONFIG_SYS_MAXARGS, 1,	do_turing_core_volt,
	"tune core volt(mv)",
	"example: tune 10\n"
);
