/******************************************************************************
*    Copyright (c) 2009-2015 by Hisi.
*    All rights reserved.
*
*    Create by Chenzetian. 2015-12-16
*
******************************************************************************/

#include <common.h>
#include <command.h>
#include <asm/processor.h>
#include <linux/compiler.h>
#include <linux/ctype.h>
#include <asm/byteorder.h>
#include <asm/unaligned.h>
#include <asm/io.h>
#include <mmc.h>

extern struct mmc *find_mmc_device(int dev_num);
extern int mmc_init(struct mmc *mmc);
extern void prepare_slave_cpu_bootcode(void);
extern void execute_init_secure_kernel(ulong addr);

#define SAVE_BOOT_SIZE 1*1024*1024//1M
#define SAVE_SECUREOS_SIZE 2*1024*1024//2M

#define FASTBOOT_TEXT_ADDR 0x10c00000
#define FASTBOOT_SAVE_ADDR 0x11000000
#define SECUREOS_SAVE_ADDR 0x11100000
#define SECUREOS_RUN_ADDR 0x3B000000

void *fastboot_text_base = (void *)FASTBOOT_TEXT_ADDR;
void *secureos_run_addr = (void *)SECUREOS_RUN_ADDR;
void *fastboot_save_addr = (void *)FASTBOOT_SAVE_ADDR;
void *secureos_save_addr = (void *)SECUREOS_SAVE_ADDR;

__attribute__((weak))
unsigned long do_go_exec (ulong (*entry)())
{
	return entry ();
}
int is_str_resume(){
    if((0x1 == readl(0xf840E51C))&&(0x1 == readl(0xf840E540)))
        return 0x1;
    else
        return 0x0;
}
void ca_resume(){
    u32 resume_addr=0;

    printf("CA Flag:%s\n",(0x1 == readl(0xf840E540))?"Y":"N");
    printf("PowerOn Flag:%s\n",(0x1 == readl(0xf840E51C))?"Y":"N");

    if(1 == is_str_resume()){
        printf("Load Secure OS From 0x%08x.\n",secureos_save_addr);
        memcpy(secureos_run_addr,secureos_save_addr,SAVE_SECUREOS_SIZE);
        
        /* flush cache after read */
        flush_cache((ulong)secureos_run_addr, SAVE_SECUREOS_SIZE);
        
        prepare_slave_cpu_bootcode();
        execute_init_secure_kernel(secureos_run_addr);
        
        resume_addr = readl(REG_BASE_SCTL+REG_SC_GEN8);//GEN8
        /* invalidate I-cache */
        asm("mcr p15, 0, r0, c7, c5, 0");
        /* mem barrier to sync up things */
        asm("mcr p15, 0, r0, c7, c10, 4");
        
        printf("Now jump to kernel:0x%08x.\n",resume_addr);
        do_go_exec ((void *)(resume_addr));
        printf("!!! Resume Error !!!\n");
    }
}

void save_boot_code(void){
    printf("Save Fastboot to 0x%08x\n",fastboot_save_addr);
    memcpy(fastboot_save_addr,fastboot_text_base,SAVE_BOOT_SIZE);
    
    printf("Save SecureOS to 0x%08x\n",secureos_save_addr);
    memcpy(secureos_save_addr,secureos_run_addr,SAVE_SECUREOS_SIZE);

}
